#ifndef FLY_H
#define FLY_H

#include <GL/gl.h>
#include <math.h>
#include <stdio.h>

#define FLOORPOINTS 21

#define FORWARD 1
#define BACKWARD -1
#define X 0
#define Y 1
#define Z 2

#define KEY_ESC		27	/* escape key */

/*  Function Prototypes  */

/* functions in fly.c */
GLvoid  printHelp( char * );
GLvoid  printControls( GLvoid );
GLvoid  initgfx( GLvoid );
GLvoid  initLighting( GLvoid );
GLvoid  drawScene( GLvoid );
GLvoid  drawShapes( GLvoid );
GLvoid  drawMovedShape( GLint, GLfloat, GLfloat, GLfloat );
GLvoid  drawShape( GLint, GLint );
GLvoid  drawTetra( GLint );
GLvoid  drawCube( GLint );
GLvoid  drawOcta( GLint );
GLvoid  drawDodeca( GLint );
GLvoid  drawIcosa( GLint );
GLvoid  drawCylinder( GLint );
GLvoid  drawSphere( GLint );
GLvoid  drawTorus( GLint );
GLvoid  drawCone( GLint );
GLuint  createOutlineFont( GLvoid );
GLuint  createFilledFont( GLvoid );
GLvoid  renderString( GLuint, GLubyte * );

/* functions in flyutil.c */
GLvoid  reshape( GLsizei, GLsizei );
GLvoid  computeFloor( GLvoid );
GLvoid  drawFloor( GLvoid );
GLvoid  drawFloorWire( GLvoid );
GLvoid  drawFloorFilled( GLvoid );
GLvoid  setDrawStyle( GLvoid );
GLvoid  keyboard( GLubyte key, GLint x, GLint y );
GLvoid  specialkeys( GLint key, GLint x, GLint y );
GLvoid  mouse( GLint button, GLint state, GLint x, GLint y );
GLvoid  motion( GLint x, GLint y );
GLvoid  startMove( GLint button, GLint x, GLint y );
GLvoid  stopMove( GLvoid );
GLvoid  drawNormals( GLvoid );
GLvoid  toggleDrawNormals( GLvoid );
GLvoid  toggleShowGrid( GLvoid );
GLvoid  toggleBlend( GLvoid );
GLvoid  enableBlending( GLvoid );
GLvoid  disableBlending( GLvoid );
GLvoid  computeNormals( GLvoid );
GLvoid  setAutopilot( GLvoid );
GLvoid  setDebug( GLvoid );
GLvoid  updatePosition( GLint x, GLint y );
GLvoid  moveEye( GLvoid );
GLvoid  initEye(GLvoid);
GLvoid  animate( GLvoid );
GLvoid  visibility( GLint );

GLboolean  inMotion(GLvoid);

#endif
